<template>
  <div class="sbo-sidebar">
    <el-dialog
      v-model="showSidebar"
      :before-close="toggleSidebar"
      destroy-on-close
      width="80vw"
      custom-class="sidebar-dialog"
      :show-close="false"
    >
      <div>
        <div class="flex flex-col gap-2">
          <div>
            <div v-if="auth" class="flex justify-between p-3">
              <div class="username flex gap-2 items-center">
                <svg-icon svg-name="icon-fAccount" class="w-6 h-6" />
                <span>{{ username }}</span>
              </div>
              <div class="w-6 h-6" @click="logout">
                <svg-icon svg-name="icon-sign-out" class="w-full h-full" />
              </div>
            </div>
            <div v-else class="flex items-center justify-between gap-3 p-3">
              <button
                class="btn bg-secondary"
                @click="toggleAuthModal('login')"
              >
                <span class="text-base font-bold leading-4">{{
                  $t("capital_login")
                }}</span>
              </button>
              <button
                class="btn bg-primary"
                :id="ID.SIGNUP"
                @click="toggleAuthModal('register')"
              >
                <span class="text-base font-bold leading-4 pointer-events-none">{{
                  $t("joinnow")
                }}</span>
              </button>
              <language />
            </div>
            <div
              class="h-[calc(100vh-135px)] mx-auto overflow-scroll pb-[70px]"
            >
              <tamplate v-if="auth">
                <el-collapse class="p-[15px]">
                  <el-collapse-item
                    :title="$t('wallet')"
                    class="border-[3px] border-[var(--background2)] rounded-md"
                  >
                    <div
                      class="refresh-balance flex justify-end items-baseline border-b-[1px] border-[var(--text)] mb-[15px]"
                    >
                      <span>{{ $t("refresh") }}</span>
                      <button
                        class="block text-[5vw] text-x88a1 ml-2"
                        @click="getBalance"
                      >
                        <icons :is-refresh="true" class="w-3.5 h-3.5" />
                      </button>
                    </div>
                    <div
                      v-for="(wallet, index) in walletList"
                      :key="index"
                      class="flex justify-between w-full"
                    >
                      <span>{{ wallet.getWalletNameForDisplay() }} :</span>
                      <span
                        >{{ wallet.getBetCreditForDisplay() }}
                        {{ currency }}</span
                      >
                    </div>
                  </el-collapse-item>
                </el-collapse>
                <div
                  v-if="isShowDepositWithdrawal"
                  class="side-nav-transaction grid grid-cols-3 bg-[var(--background2)] h-[69px] w-full"
                >
                  <nuxt-link
                    to="/deposit"
                    class="deposit gap-2 flex flex-col justify-center items-center border-r-[1px] border-[var(--text)]"
                    @click="toggleSidebar"
                    v-if="isCashPlayer"
                  >
                    <svg-icon
                      svg-name="deposit-bank-icon"
                      class="icon w-[24px] h-[24px]"
                    />
                    <span>{{ $t(`deposit${isBhinbhin}`) }}</span>
                  </nuxt-link>
                  <nuxt-link
                    to="/withdrawal"
                    class="withdrawal gap-2 flex flex-col justify-center items-center border-r-[1px] border-[var(--text)]"
                    @click="toggleSidebar"
                    v-if="isCashPlayer"
                  >
                    <svg-icon
                      svg-name="icon-withdrawal-money"
                      class="icon w-[24px] h-[24px]"
                    />
                    <span>{{ $t("withdrawal") }}</span>
                  </nuxt-link>
                  <nuxt-link
                    to="/transaction-history/deposit"
                    class="transaction-history gap-2 flex flex-col justify-center items-center"
                    @click="toggleSidebar"
                  >
                    <svg-icon
                      svg-name="icon-transaction-history"
                      class="icon w-[24px] h-[24px]"
                    />
                    <span>{{ $t("history") }}</span>
                  </nuxt-link>
                </div>
              </tamplate>
              <div
                v-if="menuTabHeaders.length > 0"
                class="flex flex-col items-start w-full p-3"
              >
                <nuxt-link to="/" class="w-full" @click="toggleSidebar">
                  <div class="flex flex-row items-center gap-2.5 py-2.5">
                    <svg-icon
                      svg-name="icon-home"
                      class="icon w-[24px] h-[24px]"
                    />
                    <span class="uppercase sidebar-text">{{ $t("home") }}</span>
                  </div>
                </nuxt-link>
                <sidebar-menu
                  v-for="(menu, idx) in menuTabHeaders"
                  :key="idx"
                  class="is-sbo"
                  :menu="menu"
                />
              </div>
              <div
                class="border-t-[1px] border-solid border-[color:var(--border)] opacity-50 w-full"
              ></div>
              <div class="grid grid-cols-3 p-2 gap-2 pt-4">
                <nuxt-link
                  v-if="authenticated"
                  to="/profile"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-fAccount" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("account") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated"
                  to="/transaction-history/my-promotion"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="my-promotion-icon" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("my_promotion") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated"
                  to="/transaction-history"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-statement" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("statement") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated"
                  to="/bet-history/sport"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-fBetHistory" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("my_bets") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated"
                  :to="ROUTES.ACCOUNT.PASSWORD"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-password" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("login_password") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated && isPaymentPasswordSet && isCashPlayer"
                  :to="ROUTES.ACCOUNT.PASSWORD"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-password" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("payment_password") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated && isLoginNameEnabled"
                  :to="ROUTES.ACCOUNT.PASSWORD"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <span>N</span>
                  </div>
                  <div class="side-nav-title">{{ $t("login_name") }}</div>
                </nuxt-link>
                <nuxt-link
                  v-if="authenticated && referralEnabled"
                  to="/referral/referral"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-referral" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("referral") }}</div>
                </nuxt-link>
                <template v-if="isAllowPromotionTab">
                  <nuxt-link
                    to="/promotion"
                    class="side-nav-container side-nav-promotion"
                    @click="toggleSidebar"
                  >
                    <div class="side-nav-icon">
                      <svg-icon
                        svg-name="promotion-reqular-icon"
                        class="nav-icon"
                      />
                    </div>
                    <div class="side-nav-title">{{ $t("promotion") }}</div>
                  </nuxt-link>
                </template>
                <nuxt-link
                  to="/contact-us"
                  class="side-nav-container"
                  @click="toggleSidebar"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-contact-us" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">{{ $t("contact_us") }}</div>
                </nuxt-link>
                <div
                  v-if="!agentCooperation.IsHidden"
                  class="side-nav-container"
                  @click="toggleAgentCooperation"
                >
                  <div class="side-nav-icon">
                    <svg-icon svg-name="icon-people" class="nav-icon" />
                  </div>
                  <div class="side-nav-title">
                    {{ $t("agent_cooperation") }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <template v-if="isAppDownloadEnabled">
          <a v-if="appDownloadURL === ''" :href="appUrl" download>
            <div class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color">
              <div
                class="flex flex-row items-end justify-between h-16 gap-1 px-1"
              >
                <div class="w-[68px] h-[68px]">
                  <img
                    :src="
                      getAssetImage(
                        'assets/theme/new_black_theme/app_download.png'
                      )
                    "
                    alt=""
                  />
                </div>
                <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                  <div
                    class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                  >
                    <span class="app-download-title">{{ brandName }} APP</span>
                    <span class="app-download-content"
                      >Download <br />
                      our Android APP</span
                    >
                  </div>
                  <div class="w-[78px] h-[30px]">
                    <el-button type="danger" round class="capitalize">{{
                      $t("download")
                    }}</el-button>
                  </div>
                </div>
              </div>
              <div
                class="bg-app-download"
                :style="`--appDownload: ${String(appDownload.ImagePath)};`"
              ></div>
            </div>
          </a>
          <a
            v-else
            :href="
              appDownloadURL.includes('://')
                ? appDownloadURL
                : `//${appDownloadURL}`
            "
            target="_blank"
          >
            <div class="absolute bottom-0 right-0 rounded-t-2xl bg-theme-color">
              <div
                class="flex flex-row items-end justify-between h-16 gap-1 px-1"
              >
                <div class="w-[68px] h-[68px]">
                  <img
                    :src="
                      getAssetImage(
                        'assets/theme/new_black_theme/app_download.png'
                      )
                    "
                    alt=""
                  />
                </div>
                <div class="flex flex-row items-center p-0 gap-1 h-16 z-[1]">
                  <div
                    class="flex flex-col justify-center items-start p-0 h-16 w-[98px]"
                  >
                    <span class="app-download-title">{{ brandName }} APP</span>
                    <span class="app-download-content"
                      >Download <br />
                      our Android APP</span
                    >
                  </div>
                  <div class="w-[78px] h-[30px]">
                    <el-button type="danger" round class="capitalize">{{
                      $t("download")
                    }}</el-button>
                  </div>
                </div>
              </div>
              <div
                class="bg-app-download"
                :style="`--appDownload: ${String(appDownload.ImagePath)};`"
              ></div>
            </div>
          </a>
        </template>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import SidebarMenu from "./SidebarMenu.client.vue";
import Language from "./Language.client.vue";
import { store } from "@/store";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import useBalanceInfo from "@/composables/useBalanceInfo";
import { Wallet } from "~~/models/common/wallet";

export default defineComponent({
  name: "Login",
  components: {
    SidebarMenu,
    Language,
  },
  setup() {
    // const auth = computed(() => store.state.auth);
    store.commit("updateSidebar", false);
    // store.commit("updateRegisterDialog", false);
    store.commit("updateAgentCooperationDialog", false);
    const toggleSidebar = () => {
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const toggleAgentCooperation = () => {
      store.commit(
        "updateAgentCooperationDialog",
        !store.state.showAgentCooperationDialog
      );
    };
    const showSidebar = computed(() => store.state.showSidebar);
    const authenticated = computed(() => store.state.auth);
    const activeNames = ref([]);
    const { getAssetImage, isBhinbhin } = commonHelper;
    const handleImageRender = (img: string) => {
      let src = "";
      try {
        src = getAssetImage(
          `assets/theme/new_black_theme/sidebar/${img.replace(" ", "")}.svg`
        );
      } catch (_) {
        src = "";
      }
      return src;
    };
    const {
      menuTabHeaders,
      appDownload,
      appUrl,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      agentCooperation,
      auth,
      referralEnabled,
      logout,
      username,
      isShowDepositWithdrawal,
      appDownloadURL,
    } = useHeaderComponent();
    const toggleAuthModal = (option: "login" | "register"): void => {
      if (option === "login") {
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
      if (option === "register") {
        store.commit("updateRegisterDialog", !store.state.showRegisterDialog);
      }
    };
    const { isPaymentPasswordSet, isCashPlayer } = usePaymentPassword();

    const { isLoginNameEnabled } = useLoginName();
    const { currency, wallets, getBalance } = useBalanceInfo();
    const walletList = computed(() =>
      wallets.value.map((wallet) => new Wallet(wallet))
    );
    const brandName = themePropertyHelper.getSingleThemeProperty(store.state.companyThemePropertiesFromApi.ThemeProperties, 'seo_brand_name').Text;
    return {
      toggleSidebar,
      showSidebar,
      menuTabHeaders,
      activeNames,
      appDownload,
      appUrl,
      handleImageRender,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      authenticated,
      getAssetImage,
      isAppDownloadEnabled,
      isAllowPromotionTab,
      toggleAgentCooperation,
      auth,
      agentCooperation,
      toggleAuthModal,
      referralEnabled,
      isPaymentPasswordSet,
      isLoginNameEnabled,
      isCashPlayer,
      logout,
      username,
      currency,
      walletList,
      getBalance,
      isShowDepositWithdrawal,
      brandName,
      isBhinbhin,
      appDownloadURL,
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(.nuxt-link-exact-active .text) {
  fill: var(--selected);
}
.side-nav-promotion {
  .text {
    fill: none;
    stroke: var(--text);
  }
}
.el-collapse {
  --el-collapse-header-text-color: var(--text);
  --el-collapse-content-text-color: var(--text);
}
:deep(.el-collapse-item__header) {
  background: var(--background2);
  padding: 10px;
  height: 35px;
}
:deep(.sidebar-dialog.el-dialog) {
  background: var(--background3);
}
:deep(.el-collapse-item__content) {
  padding: 10px;
}
.side-nav-container {
  display: flex;
  align-items: center;
  flex-direction: column;
  gap: 8px;
  .side-nav-icon {
    display: flex;
    align-items: center;
    justify-content: center;
    position: relative;
    width: 40px;
    height: 40px;
    border-width: 1px;
    border-color: var(--text);
    border-radius: 100%;
    .nav-icon {
      width: 24px;
      height: 24px;
    }
  }
  .side-nav-title {
    display: flex;
    justify-content: center;
    word-break: break-word;
    text-align: center;
  }
}
:deep(button.el-button) {
  width: 78px;
  height: 30px;
  background-color: var(--primary);
  border: none;
}
:deep(.el-button span) {
  @apply text-[12px] font-bold leading-[14px] text-[color:var(--textBtn)];
}
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: cover;
  }
  height: 20px;
  width: 20px;
  border-radius: 50%;
  background: #fff;
}
.nuxt-link-active {
  .sidebar-text,
  .icon-angle-right {
    color: var(--selected) !important;
  }
}

.btn {
  @apply inline-block text-center transition-colors duration-300;
  padding: 0.125rem 0.5rem !important;
  min-height: 36px;
  border-radius: 6px;
  min-width: 0;
  width: 100%;
  text-transform: capitalize;
}
</style>
<style>
.app-download-title {
  width: 98px;
  height: 14px;
  font-style: normal;
  font-weight: bold;
  font-size: 12px;
  line-height: 14px;
  color: var(--text5);
}
.app-download-content {
  font-weight: 300;
  font-size: 10px;
  line-height: 14px;
  color: var(--text5);
}
.bg-app-download {
  @apply absolute w-40 h-[3.75rem] left-[100px] top-1 rounded-t-2xl;
  background-image: var(--appDownload);
}
.bg-theme-color {
  @apply absolute w-full h-16 left-[100px] bottom-0 rounded-t-2xl;
  left: 0;
  background: var(--background2);
}
.sidebar-text {
  @apply font-normal text-sm;
  color: var(--text);
}
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}
.m-profile-menu-item:last-child {
  border-bottom: none;
}
.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--text);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.profile-menu-title {
  font-size: 14px;
  color: var(--text);
  margin-left: 8.73px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.el-collapse-item__content {
  padding-left: 10px;
}
.lang-wr-option-container {
  padding-top: 4.87px;
  padding-bottom: 4.87px;
  margin-bottom: 27px !important;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}
.nuxt-link-active.nuxt-link-exact-active.side-nav-container .text {
  fill: var(--text);
}
.nuxt-link-active.nuxt-link-exact-active.side-nav-promotion .text {
  fill: none;
}
</style>
